<?php
/**
 * @author Calcurates Team
 * @copyright Copyright © 2020 Calcurates (https://www.calcurates.com)
 * @license https://opensource.org/licenses/osl-3.0.php Open Software License (OSL 3.0)
 * @package Calcurates_ModuleMagento
 */

declare(strict_types=1);

namespace Calcurates\ModuleMagento\Block\Product\View;

use Calcurates\ModuleMagento\Model\Config;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;

class Estimation extends Template
{
    /**
     * @var Config
     */
    private $configProvider;

    /**
     * @var \Magento\Framework\App\Http\Context
     */
    private $httpContext;

    public function __construct(
        Context $context,
        Config $configProvider,
        \Magento\Framework\App\Http\Context $httpContext,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->configProvider = $configProvider;
        $this->httpContext = $httpContext;
    }

    public function getJsLayout()
    {
        $isLoggedIn = $this->httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH);

        $this->jsLayout['components']['calcurates_rates']['storeCode'] = $this->_storeManager->getStore()->getCode();
        $this->jsLayout['components']['calcurates_rates']['isLoggedIn'] = $isLoggedIn;
        $this->jsLayout['components']['calcurates_rates']['productId'] = $this->getProductId();
        $this->jsLayout['components']['calcurates_rates']['fallbackMessage'] =
            $this->configProvider->getShippingOnProductFallbackMessage();

        return parent::getJsLayout(); // TODO: Change the autogenerated stub
    }

    /**
     * @return int
     */
    public function getProductId(): int
    {
        return (int)$this->getRequest()->getParam('id');
    }
}
